/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package operacije;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 *
 * @author student1
 */
public abstract class Operacija {

    protected double operand1;
    protected double operand2;
    protected double rezultat;

    private void unesiVrednosti() throws Exception {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        try {
            String sOperand1 = br.readLine();

            String sOperand2 = br.readLine();
            izvrsiValidaciju(sOperand1, sOperand2);
        } catch (IOException ioe) {
            System.out.println("Doslo je do greske u radu sa tastaturom. " + ioe.getMessage());
            throw new Exception("Doslo je do greske u radu sa tastaturom. ");
        }
    }

    protected void izvrsiValidaciju(String s1, String s2) throws Exception {
        try {
            operand1 = Double.parseDouble(s1);
            operand2 = Double.parseDouble(s2);
        } catch (NumberFormatException nfe) {
            System.out.println("Greska pri konverziji unetog teksta u broj. " + nfe.getMessage());
            throw new Exception("Unos [ " + s1 + " , " + s2 + " ] ne moze biti konvertovan u realan broj.");
        }
    }

    protected abstract void izracunaj();

    protected abstract void prikaziRezultat();

    public void izvrsi() {
        try {
            unesiVrednosti();
            izracunaj();
            prikaziRezultat();
        } catch (Exception ex) {
            System.out.println(ex.getMessage());
        }
    }

}
